// Written by retoor@molodetz.nl

// This JavaScript class provides functionality to schedule repeated execution of a function or delay its execution using specified intervals and timeouts.

// No external imports or includes are used in this code.

// MIT License
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

export class Schedule {
  constructor(msDelay = 100) {
    this.msDelay = msDelay;
    this._once = false;
    this.timeOutCount = 0;
    this.timeOut = null;
    this.interval = null;
  }

  cancelRepeat() {
    clearInterval(this.interval);
    this.interval = null;
  }

  cancelDelay() {
    clearTimeout(this.timeOut);
    this.timeOut = null;
  }

  repeat(func) {
    if (this.interval) {
      return false;
    }
    this.interval = setInterval(() => {
      func();
    }, this.msDelay);
  }

  delay(func) {
    this.timeOutCount++;
    if (this.timeOut) {
      this.cancelDelay();
    }
    const me = this;
    this.timeOut = setTimeout(() => {
      func(me.timeOutCount);
      clearTimeout(me.timeOut);
      me.timeOut = null;
      me.cancelDelay();
      me.timeOutCount = 0;
    }, this.msDelay);
  }
}
